      subroutine evolvePDF(x,Q,f)
      implicit none
      integer Eorder,index,iset,iiset
      character*16 name
      integer nmem,ndef,mem
      common/NAME/name,nmem,ndef,mem
      common/SET/iiset
      real*8 x,Q,Q2fit,alfas
      real*8 f(-6:6)

      save
*
      if (name.eq.'QCDNUM') call QCDNUMevolve(x,Q,f)
      if (name.eq.'QCDNUM_MRST') call QCDNUMevolve(x,Q,f)
      if (name(1:11).eq.'QCDNUM_ZEUS') call ZEUSevolve(x,Q,f)
      if (name.eq.'CTEQ5grid') call CTEQ5evolve(x,Q,f)
      if (name.eq.'CTEQ6grid') call CTEQ6evolve(x,Q,f)
      if (name.eq.'EVLCTEQ') call EVLCTEQevolve(x,Q,f)
      if (name.eq.'MRSTgrid') call MRSTevolve(x,Q,f)
      if (name.eq.'MRSTpdf') call QCDNUMevolve(x,Q,f)
      if (name.eq.'MRST') call QCDNUMevolve(x,Q,f)
      if (name.eq.'A02') call A02evolve(x,Q,f)
      if (name.eq.'H12000') call H1evolve(x,Q,f)
      if (name.eq.'GRV') call GRVevolve(x,Q,f)
      return
*
      entry readevolve
*
      read(1,*) name      
*
      if (name.eq.'QCDNUM') call QCDNUMread
      if (name.eq.'QCDNUM_MRST') call QCDNUMread
      if (name(1:11).eq.'QCDNUM_ZEUS') call ZEUSread
      if (name.eq.'CTEQ5grid') call CTEQ5read
      if (name.eq.'CTEQ6grid') call CTEQ6read
      if (name.eq.'EVLCTEQ') call EVLCTEQread
      if (name.eq.'MRSTgrid') call MRSTread
      if (name.eq.'MRSTpdf') call QCDNUMread
      if (name.eq.'MRST') call QCDNUMread
      if (name.eq.'A02') call A02read
      if (name.eq.'H12000') call H1read
      if (name.eq.'GRV') call GRVread
      return
*
      entry alfasevolve(alfas,Q)
      if (name.eq.'QCDNUM') call QCDNUMalfa(alfas,Q)
      if (name.eq.'QCDNUM_MRST') call QCDNUMalfa(alfas,Q)
      if (name(1:11).eq.'QCDNUM_ZEUS') call ZEUSalfa(alfas,Q)
      if (name.eq.'CTEQ5grid') call CTEQ5alfa(alfas,Q)
      if (name.eq.'CTEQ6grid') call CTEQ6alfa(alfas,Q)
      if (name.eq.'EVLCTEQ') call EVLCTEQalfa(alfas,Q)
      if (name.eq.'MRSTgrid') call MRSTalfa(alfas,Q)
      if (name.eq.'MRSTpdf') call QCDNUMalfa(alfas,Q)
      if (name.eq.'MRST') call QCDNUMalfa(alfas,Q)
      if (name.eq.'A02') call A02alfa(alfas,Q)
      if (name.eq.'H12000') call H1alfa(alfas,Q)
      if (name.eq.'GRV') call GRValfa(alfas,Q)
      return
*
      entry initevolution(Eorder,Q2fit)
      if (name.eq.'QCDNUM') call QCDNUMinit(Eorder,Q2fit)
      if (name(1:11).eq.'QCDNUM_ZEUS') call ZEUSinit(Eorder,Q2fit)
      if (name.eq.'CTEQ5grid') call CTEQ5init(Eorder,Q2fit)
      if (name.eq.'CTEQ6grid') call CTEQ6init(Eorder,Q2fit)
      if (name.eq.'EVLCTEQ') call EVLCTEQinit(Eorder,Q2fit)
      if (name.eq.'MRSTgrid') call MRSTinit(Eorder,Q2fit)
      if (name.eq.'QCDNUM_MRST') then 
        call QCDNUMinit(Eorder,Q2fit)
	call QNLSET('BMARK',.TRUE.)
      endif 
      if (name.eq.'A02') call A02init(Eorder,Q2fit)
      if (name.eq.'H12000') call H1init(Eorder,Q2fit)
      if (name.eq.'GRV') call GRVinit(Eorder,Q2fit)
      return
*
      entry initPDF(iset)
      iiset = iset
      if (name.eq.'QCDNUM') then
         call InitEvolvePDF(iset)
         call QCDNUMpdf(iset)
      endif
      if (name.eq.'QCDNUM_MRST') then
         call InitEvolvePDF(iset)
         call QCDNUMpdf(iset)
      endif
      if (name(1:11).eq.'QCDNUM_ZEUS') then
         call InitEvolvePDF(iset)
         call ZEUSpdf(iset)
      endif
      if (name.eq.'MRST') then
         call InitEvolvePDF(iset)
         call QCDNUMpdf(iset)
      endif
      if (name.eq.'MRSTpdf') then
         call InitEvolvePDF(iset)
         call QCDNUMpdf(iset)
      endif
      if (name.eq.'EVLCTEQ') then
         call InitEvolvePDF(iset)
         call EVLCTEQpdf(iset)
      endif
      if (name.eq.'H12000') then
         call InitEvolvePDF(iset)
         call H1pdf(iset)
      endif
      if (name.eq.'CTEQ5grid') call CTEQ5pdf(iset)
      if (name.eq.'CTEQ6grid') call CTEQ6pdf(iset)
      if (name.eq.'MRSTgrid') call MRSTpdf(iset)
      if (name.eq.'A02') call A02pdf(iset)
      if (name.eq.'GRV') call GRVpdf(iset)
      return
*
      end
